<!doctype html>
<html>
	<head>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

		<title>C Programming</title>

		<link rel="icon" type="image/png" href="images/org_symbol.png" />
		<link rel="stylesheet" href="css/reset.css">
		<link rel="stylesheet" href="css/reveal.css">
		<link rel="stylesheet" href="css/theme/league.css" id="theme">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="lib/css/monokai.css">

		<!-- Printing and PDF exports -->
		<script>
			var link = document.createElement( 'link' );
			link.rel = 'stylesheet';
			link.type = 'text/css';
			link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
			document.getElementsByTagName( 'head' )[0].appendChild( link );
		</script>
	</head>
	<body>

		<div style="background:green; left:0; right:0; position:absolute; height:30px;">
			<div style="text-align: center;">(U)Unclassified</div>
		</div>
		<div class="reveal">
			<div class="slides">
				<section data-background-image="images/org_symbol.png" data-background-size="13%" data-background-position="top 5% left 5%">
					<h1>Intro to C Programming</h1>
					<p>39th Information Operations Squadron Detachment 1</p>				
				</section>
				
				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
					<h1>Introduction</h1>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
						instructor view!!
					</aside>
					</section>

					<section>
                        <h2>In This Section:</h2>
                        <ul>
                            <li>Terminology</li>
                            <li>Language Features</li>
                            <li>C Specifics</li>
                            <li>Setting Up The Environment</li>
                            <li>Documentation</li>
                        </ul>
                    </section>

                    <section>
                        <h2>By the end of this section you should:</h2>
                        <ul>
                            <li>Know how to setup your C programming environment on both Windows and Linux</li>
                            <li>The basics of the different text editors</li>
                            <li>Some basic programming definition</li>
                            <li>The general and specific features to the C Language (on a basic level)</li>
                        </ul>
                    </section>

                    <section>
						<h2>LESSON OBJECTIVES:</h2>
						<h3><a href="../Introduction/objectives.html" target="_top">Link To Objectives</a></h3>
                    </section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h1>Programming Terminology</h1>
					</section>

					<section>
						<p>High vs Low Level programming.</p>

						<table>
							<tbody>
								<tr>
									<th>
									<p><span style="font-size:0.5em;">S.NO</span></p>
									</th>
									<th>
									<p><span style="font-size:0.5em;">High Level Language</span></p>
									</th>
									<th>
									<p><span style="font-size:0.5em;">Low Level Language</span></p>
									</th>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">1.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is programmer friendly language.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is a machine friendly language.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">2.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">High level language is less memory efficient.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">Low level language is high memory efficient.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">3.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is easy to understand.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is tough to understand.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">4.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is simple to debug.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is complex to debug comparatively.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">5.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is simple to maintain.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is complex to maintain comparatively.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">6.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is portable.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is non-portable.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">7.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It can run on any platform.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is machine-dependent.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">8.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It needs compiler or interpreter for translation.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It needs assembler for translation.</span></p>
									</td>
								</tr>
								<tr>
									<td>
									<p><span style="font-size:0.5em;">9.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is used widely for programming.</span></p>
									</td>
									<td>
									<p><span style="font-size:0.5em;">It is not commonly used now-a-days in programming.</span></p>
									</td>
								</tr>
							</tbody>
						</table>
						
						<p><span style="font-size:0.5em;"><a href="https://www.geeksforgeeks.org/difference-between-high-level-and-low-level-languages/" target="_blank">Source: Here </a></span></p>
					</section>
					
					<section>
						<h3>High Level Programming</h3>
						<p>Hello World in Python</p>
						<code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
                            print("Hello, world!")
                        </span></code>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
                    </section>
                    
					<section>
						<h3>Low Level Programming</h3>
						<p>Hello World in Assembly</p>
						<div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">SECTION .data
greeting     db      'Hello, World!', 0Ah 
							
SECTION .text
global  _start
							
_start:
							
mov     edx, 14
mov     ecx, greeting
mov     ebx, 1
mov     eax, 4
int     80h

mov     ebx, 0
mov     eax, 1
int     80h</code></pre></div></div>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>

					<section>
						<h3>C Programming</h3>
						<p>Hello World in C</p>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
#include &lt;stdio.h&gt;

int main(){
	printf("Hello, World!");
	return 0;
}
                        </span></code></pre>
						<aside class="notes">
							Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
							instructor view!!
						</aside>
					</section>

					<section>
						<h2>Statements</h2>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
printf("Hello, World!\n"); // This is a statement)
						</span></code></pre>
						<p>and...</p>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
if(something){
	do (something);
}
						</span></code></pre>

						<aside class="notes">
							Statements are snippets of code that do things. They are human readable text that a compiler will turn into executable statements when compiled.
						</aside>
					</section>

					<section>
						<h2>Blocks</h2>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
if (something)
{
	if (somethingElse)
	{
		do something;
	}
}
else if (something1)
{
	do something;
}
else
{
	do nothing;
}
						</span></code>

						<aside class="notes">
							A block is a group of executable statements.
						</aside>
					</section>

					<section>
						<h2>Functions</h2>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int addNumbers(int a, int b)
{
	return a + b;
}
						</span></code></pre>

						<aside class="notes">
							A function is a block of code written to perform a specific task.
						</aside>
					</section>

					<section>
						<h2>Whitespace</h2>
					
						<ul>
							<li>Spaces (' ')</li>
							<li>Tabs ('\t')</li>
							<li>Newline ('\n')</li>
							<li>Vertical Tab('\v')</li>
							<li>Carriage Return('\r')</li>
						</ul>
						<aside class="notes">
							Whitespace are tabs, spaces and newline/End of Line (EOL) characters that separate text characters in source code. 
							In other words, any character or series of whitespace characters that represent horizontal or vertical space.
						</aside>
					</section>

					<section>
						<h2>Scope</h2>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int x = 20; //Global variable

int main(){
	int y = 30; //Local variable
	return 0;
}

int someFunction() {
	printf("%i\n", x); // I can access x here
	printf("%i\n", y); // ERROR: I cannot access y here.
	return 0;
}
						</span></code></pre>

						<aside class="notes">
							Scope is the level at which a piece of data or function is visible.
						</aside>
					</section>
					
										<section>
											<h2>Text Editors</h2>
											<p>In this class, we will use <a href="https://github.com/microsoft/vscode">VS Code</a> our primary text editor.:</p>
											<p>Some other text editors you can explore are:</p>
											<ul>
												<li><a href="https://github.com/atom/atom">Atom</a></li>
												<li><a href="https://www.sublimetext.com/">Sublime Text (not Open Source)</a></li>
												<li><a href="https://git.savannah.gnu.org/cgit/nano.git/tree/README.GIT">Nano</a></li>
												<li><a href="https://github.com/vim/">Vi/Vim</a></li>
											</ul>
											<aside class="notes">
												Add notes here.
											</aside>
										</section>

					<section>
						<h2>Integrated Development Environment (IDE)</h2>
						<p> In this class we will use <b>Visual Studio</b></p>
						<aside class="notes">
							Add notes here.
						</aside>
					</section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h1>C Language Features</h1>
					</section>

					<section>
						<h2>Control Flow</h2>
						<p>C is a free-format procedural language. It follows commands in order written out by the programmer, and several statements can share a line.</p>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
printf("Integer?\n"); scanf("%d", &i); i = i / 10;

// vs

printf("Integer?\n");
scanf("%d", &i);
i = i / 10;
</span></code></pre>
					</section>

					<section>
						<h2>Main</h2>
						<p>All program execution begins and ends with main. If another function is called, it must be done inside of main.</p>
						<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int main(){
	MyFunction();
	return 0;
}
</span></code></pre>
					</section>

					<section>
						<h2>Data Types</h2>
						<p>In C, data can be interpreted in different types, which determine how the binary is understood</p>
						<aside class="notes">
							Within C, Objects, functions, and expressions have a property called type,
							which determines the interpretation of the binary value stored in an object or evaluated by the expression.
						</aside>
					</section>

					<section>
                        <h2>Data Types</h2>
                        <img src="../assets/VarTypes.png" alt="Variable names">
					</section>
					
					<section>
                        <h2>Array</h2>
                        <p>A collection of values of the same data type stored in memory.</p>
                        <img src="../assets/array1.png" alt="Array of ints">
                        <aside class="notes">
                            ints are 4 bytes in this example
                        </aside>
                    </section>

                    <section>
                        <h2>String</h2>
                        <p>An array of chars</p>
                        <img src="../assets/string1.png" alt="Array of ints">
                        <aside class="notes">
                            Add notes here
                        </aside>
					</section>
					
                    <section>
                        <h2>Structures</h2>
                        <p>A group of variables.</p>
                        <pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
    struct birthday {
        char name[20];
        int day;
        int month;
        int year;
    }
                        </span></code></pre>
                        <aside class="notes">
                            Add notes here
                        </aside>
                    </section>

				</section>

				<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
						<h1>C Specifics</h1>
					</section>

                    <section>
                        <h2>Pointers</h2>
                        <p>Variables that point at the memory address of another variable</p>
                        <img src="../assets/pointers_xkcd.png" alt="Pointers from xkcd">
                        <p style="font-size: 80%"><a href="https://xkcd.com/138/">XKCD</a></p>
                        <aside class="notes">
                            Add notes here
                        </aside>
                    </section>

				<section>
					<h2>Dynamic Memory Allocation</h2>
					<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
int* func()
{
	int* x = malloc(1024); // Allocate one kb
	return x;
}

int* x = func(); // still allocated after function end

free(x); // free to prevent crash
					</span></code></pre>
					<aside class="notes">
						The malloc() function allocates size bytes and returns a pointer to
      					the allocated memory.  The memory is not initialized.
					</aside>
				</section>

				<section>
					<h2>Comments in C</h2>
					<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
// This is a comment in C
/* This is a 
M u l t i l i n e
comment in C */
					</span></code></pre>
					<aside class="notes">
						Add notes here
					</aside>
				</section>

				<section>
					<h2>Filenames</h2>
					<ul>
						<li>Header Files (.h)</li>
						<li>Object Files (.o)</li>
						<li>Source Code (.c)</li>
					</ul>
					<aside class="notes">
						Add notes here.
					</aside>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
			data-background-position="top 5% left 5%">
				<section>
					<h1>Setting up C</h1>
				</section>

				<section>
					<h2>Compiling C</h2>
					<p>C is a <b>compiled language</b>, our code is actually "translated" into machine code before it is run.</p>
				</section>

				<section>
					<h2>Installing a compiler</h2>
					<ul>
						<li>Windows: <a href="https://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win32/Personal%20Builds/mingw-builds/installer/mingw-w64-install.exe/download">MinGW-x64</a></li>
						<li>Linux: <a href=https://gcc.gnu.org>GCC</a></li>
					</ul>
				</section>

				<section>
					<h2>Setting up VSCode to Run C</h2>
					<ul>
						<li>VS Code Windows <a href="https://code.visualstudio.com/docs/cpp/config-mingw">Walkthrough</a></li>
						<li>VS Code Linux <a href="https://code.visualstudio.com/docs/cpp/config-linux">Walkthrough</a></li>
						<li>VS Code WSL <a href="https://code.visualstudio.com/docs/cpp/config-wsl">Walkthrough</a></li>
						<li>Extension <a href=https://marketplace.visualstudio.com/items?itemName=ms-vscode.cpptools>here</a></li>
						<li>Or search C C++ the Extensions in VSCode</li>
					</ul>
				</section>

				<section>
					<h2>Greetings, Universe!</h2>
					<div class="sl-block" data-block-type="code" data-name="code-081686"><div class="sl-block-content notranslate" data-highlight-theme="monokai" data-code-frame="none" style="z-index: 10;"><pre style="font-size: 16px; line-height: 19px;"><code data-line-numbers="">
// Hello World is thinking too small. We need ambition!
// We want to greet the enitre Universe

#include &ltstdio.h&gt

int main() {
	printf("Greetings, Universe!");
	return 0;
}</code></pre></div></div>
				</section>

				<section>
					<h2>GNU C Complier (GCC)</h2>
					<p>To compile with GCC:</p>
					<pre><code data-trim="" data-noescape="" class="hljs pony"><span class="hljs-string">
gcc hello.c
./a.out
					</span></code></pre>
					<aside class="notes">
						This needs more explaination, but I figure not on slides.
					</aside>
				</section>
			
			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
			data-background-position="top 5% left 5%">

				<section>
					<h2>MSDN Documentation</h2>
					<p>The Microsoft Documentation for the C Language is available <a href=https://docs.microsoft.com/en-us/cpp/c-language/c-language-reference?view=vs-2019>here</a>.</p>
					<aside class="notes">
						sample Aside info
						
					</aside>
				</section>

				<section>
					<h2>Linux Man Pages</h2>
					<p>Linux has man pages for:</p>
					<ul>
						<li>stdio.h | user@hostname:~$ man stdio</li>
						<li>malloc  | user@hostname:~$ man malloc</li>
						<li>printf  | user@hostname:~$ man printf</li>
						<li>string  | user@hostname:~$ man string</li>
					</ul>
					<aside class="notes">
						Sample Aside information
	
					</aside>
				</section>

			</section>

			<section data-background-image="images/org_symbol.png" data-background-size="8%"
				data-background-position="top 5% left 5%">

					<section>
					<h1>Questions</h1>
					<aside class="notes">
						Put your instructor notes in these 'aside' sections. Press 'F' for full screen! Press 'S' for
						instructor view!!
					</aside>
					</section>

					<section>
                        <h2>In This Section:</h2>
                        <ul>
                            <li>Terminology</li>
                            <li>Language Features</li>
                            <li>C Specifics</li>
                            <li>Setting Up The Environment</li>
                            <li>Documentation</li>
                        </ul>
                    </section>

                    <section>
                        <h2>Objectives</h2>
                    </section>

				</section>
            
			</div>
		</div>

		
			
		<!-- DO NOT TOUCH -->
		<script src="js/reveal.js"></script>

		<script>
			Reveal.initialize({
				slideNumber: true,
				hash: true,
				menu: {
					side: 'left',
					width: 'normal',
					numbers: true,
					titleSelector: 'h1, h2, h3, h4, h5, h6',
					useTextContentForMissingTitles: false,
					hideMissingTitles: false,
					markers: true,
					custom: false,
					themes: true,
					themesPath: 'css/theme/',
					transitions: true,
					openButton: true,
					openSlideNumber: true,
					keyboard: true,
					sticky: true,
					autoOpen: true,
					delayInit: false,
					openOnInit: false,
					loadIcons: true
				},
				dependencies: [
					{ src: 'plugin/markdown/marked.js' },
					{ src: 'plugin/markdown/markdown.js' },
					{ src: 'plugin/highlight/highlight.js' },
					{ src: 'plugin/notes/notes.js', async: true },
					{ src: 'plugin/reveal.js-menu/menu.js' }
				]
			});
			Reveal.configure({slideNumber: true})
		</script>
	</body>
</html>
